
/*            ARDUI_Sony_Visca
 *            ----------------
 *  Ce programme permet la commande du zoom
    des cameras Sony (Protocole Visca en RS232)
    La mise au point est automatique.
    Entrée RxD de la camera sur Pin D4 Arduino

 Information sur Mon site  http://f5mna.free.fr
 31/01/2016

*/

#include <SoftwareSerial.h>
SoftwareSerial SerialRS = SoftwareSerial(3, 4);

const int ZoomPlus = 10;
const int ZoomMoins = 11;
int valPlus, valMoins, Pause;

void setup() {

  SerialRS.begin (9600);
  Serial.begin(9600);

  pinMode (ZoomPlus, INPUT);
  pinMode (ZoomMoins, INPUT);
  Pause = 0;  // N'envoie qu'un seul ordre Stop dans la boucle
  //Setup caméra
  //Adresse
  byte dataAdr[4] = {0x88, 0x30, 0x01, 0xFF};
  for (int i = 0; i < 4; i++)  SerialRS.write(dataAdr[i]);     //envoi les données de la commande

  //Clear
  byte dataClear[5] = {0x88, 0x01, 0x00, 0x01, 0xFF};
  for (int i = 0; i < 5; i++)  SerialRS.write(dataClear[i]);   //envoi les données de la commande

  //Auto_focus
  byte dataAutoFoc[6] = {0x81, 0x01, 0x04, 0x38, 0x02, 0xFF};
  for (int i = 0; i < 6; i++)   SerialRS.write(dataAutoFoc[i]);     //envoi les données de la commande
  }


void loop() {

  //Zoom ++
  valPlus = digitalRead(ZoomPlus);
  if (valPlus == 1) {
    byte dataVal[6] = {0x81, 0x01, 0x04, 0x07, 0x27, 0xFF}; // Vitesse: modifier 0x27 de 0x20 à 0x27 (V Maxi)
    for (int i = 0; i < 6; i++){
    SerialRS.write(dataVal[i]);      //envoi les données de la commande
    Serial.print  (dataVal[i],HEX);}
    Serial.println  ("  Zoom ++");
    Pause = 0;
  }

  //Zoom --
  valMoins = digitalRead(ZoomMoins);
  if (valMoins == 1) {
    byte dataVal[6] = {0x81, 0x01, 0x04, 0x07, 0x37, 0xFF}; // Vitesse: modifier 0x37 de 0x30 à 0x37 (V Maxi)
    for (int i = 0; i < 6; i++){
    SerialRS.write(dataVal[i]);      //envoi les données de la commande
    Serial.print  (dataVal[i],HEX);}
    Serial.println  ("  Zoom --");
    Pause = 0;
  }

  //Stop
  if ((valPlus == 0) and (valMoins == 0) and (Pause == 0)) {
    byte dataVal[6] = {0x81, 0x01, 0x04, 0x07, 0x00, 0xFF} ;    
    for (int i = 0; i < 6; i++){
    SerialRS.write(dataVal[i]);     //envoi les données de la commande
    Serial.print  (dataVal[i],HEX);}
    Serial.println  ("  Stop");
    delay (250);
    
  //Auto_focus
    byte dataAutoFoc[6] = {0x81, 0x01, 0x04, 0x38, 0x02, 0xFF};
    for (int i = 0; i < 6; i++){
    SerialRS.write(dataAutoFoc[i]);      //envoi les données de la commande
    Serial.print  (dataAutoFoc[i],HEX);}
    Serial.println  ("  Auto focus");
    Pause = 1;
  }
}
